/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: MediaPlayer.java,v a52511a71d18 2010/06/26 12:40:42 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.media;

import javax.annotation.Nonnegative;
import javax.annotation.Nonnull;
import java.io.IOException;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public interface MediaPlayer
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public static interface Controller
      {
        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void start();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void stop();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void pause();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        @Nonnegative
        public int getDuration();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        @Nonnegative
        public int getPosition();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void setPosition (@Nonnegative int position);

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public boolean isPlaying();

        /***************************************************************************************************************
         *
         *
         **************************************************************************************************************/
        public void dispose();
      }

    /*******************************************************************************************************************
     *
     * {@inheritDoc}
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    public Controller play (@Nonnull Media media)
      throws IOException;

    /*******************************************************************************************************************
     *
     *
     *
     ******************************************************************************************************************/
    public void stop();
  }
